﻿using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace KendoUIMvcApplication2.Controllers
{
    public class HomeController : Controller
    {

        [AllowAnonymous]
        public ActionResult Index()
        {
            var container = BuildNavigationMockList();
            return View(container);
        }

        private List<string> BuildNavigationMockList()
        {
            var list = new List<string>();
            list.Add("Category 1");
            list.Add("Category 2");
            return list;
        }

        [AllowAnonymous]
        public ActionResult DocumentGrid(string id)
        {
            var dt = this.GetMockData();   
           return PartialView("~/Views/Home/DocumentGrid.cshtml", dt);
        }

        [AllowAnonymous]
        public ActionResult GetDocuments([DataSourceRequest]DataSourceRequest request, string id)
        {
            //don't care about id
            var model = GetMockData();            
            
            return Json(model.ToDataSourceResult(request), JsonRequestBehavior.AllowGet);            
        }

        [AllowAnonymous]
        public ActionResult GetDocumentTypes([DataSourceRequest]DataSourceRequest request)
        {
            var model = this.BuildNavigationMockList();
            
            return Json(model.ToDataSourceResult(request), JsonRequestBehavior.AllowGet);
        }


        [AllowAnonymous]
        public bool SaveGridSettings([DataSourceRequest]DataSourceRequest request/*, string docTypeId*/)
        {
            var filters = request.Filters;
            var groups = request.Groups;
            var page = request.Page;
            var pageSize = request.PageSize;
            var gridSort = request.Sorts;
            //_settings.CollectorGridFilter = (request.Filters == null)? null: request.Filters.ToString();
            //_settings.CollectorGridGroup = (request.Groups == null) ? null : request.Groups.ToString();
            //_settings.CollectorGridPage = request.Page;
            //_settings.CollectorGridPageSize = request.PageSize;
            //_settings.CollectorGridSort = (request.Sorts == null) ? null : request.Sorts.ToString();
            return true;
        }  
     

        private DataTable GetMockData()
        {
            var dt = new DataTable();
            dt.Columns.Add("Id");
            dt.Columns.Add("Name");
            dt.Columns.Add("DataType");
            dt.Columns.Add("DateCreated");
            dt.Columns.Add("Owner");

            dt.Rows.Add(new object[] { Guid.NewGuid(), "Item 1", "Type x", DateTime.Now, "Boo Radley" });
            dt.Rows.Add(new object[] { Guid.NewGuid(), "Item 2", "Type y", DateTime.Now, "Mike Hunt" });
            dt.Rows.Add(new object[] { Guid.NewGuid(), "Item 3", "Type z", DateTime.Now, "Seymour Butz" });
            dt.Rows.Add(new object[] { Guid.NewGuid(), "Item 4", "Type x", DateTime.Now, "Heywood J. Something" });

            return dt;
        }
  
    }
}
